﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Styx.Common;
using System.Windows.Forms;
using Styx.WoWInternals;
using System.Windows.Media;
using System.Runtime.InteropServices;

namespace RogueFirst.Core.Managers
{
    class Hotkey_Manager
    {
        public static bool keysRegistered { get; set; }
        public static bool aoeOn { get; set; }
        //public static bool cooldownsOn { get; set; }
        public static bool cooldownsOn = false;
        public static bool manualOn { get; set; }
        //public static bool AlwaysSpeedOn = { get; set; }
        public static bool AlwaysSpeedOn = true;
        public static bool PickPocketOn { get; set; }
        public static bool HealingOn { get; set; }
        //public static bool StealthOn { get; set; }
        public static bool StealthOn = true;
        public static bool FeintOn = false;
        public static bool RaidOn = false;
		public static bool SoloOn = false;
        public static bool autoaoeOn = false;
        public static bool autoVanishOn = false;

        [DllImport("user32.dll")]
        private static extern short GetAsyncKeyState(Keys vKey);

        public static bool IsKeyDown(Keys vKey)
        {
            return (GetAsyncKeyState(vKey) != 0);
        }


        #region [Method] - Hotkey Registration
            public static void registerHotKeys()
            {
                if (keysRegistered)
                    return;
                HotkeysManager.Register("aoeOn", Keys.D1, ModifierKeys.Control, ret =>                           //AOE              1
                {
                    aoeOn = !aoeOn;
                    Logging.Write(Colors.Azure, aoeOn ? "AoE Mode: Enabled!" : "AoE Mode: Disabled");
                });

                HotkeysManager.Register("cooldownsOn", Keys.D2, ModifierKeys.Control, ret =>                     //CDS              2
                {
                    cooldownsOn = !cooldownsOn;
                    Logging.Write(Colors.Azure, cooldownsOn ? "Cooldowns: Enabled!" : "Cooldowns: Disabled!");
                });

                HotkeysManager.Register("manualOn", Keys.L, ModifierKeys.Alt, ret =>                        //MANUAL
                {
                    manualOn = !manualOn;
                    Logging.Write(Colors.Azure,manualOn ? "Manual Mode: Enabled!" : "Manual Mode: Disabled");
                });

                HotkeysManager.Register("AlwaysSpeed", Keys.D5, ModifierKeys.Control, ret =>                     //SPEED            5
                {
                    AlwaysSpeedOn = !AlwaysSpeedOn;
                    Logging.Write(Colors.Azure, AlwaysSpeedOn ? "Burst of Speed when moving: Enabled!" : "Burst of Speed when moving: Disabled!");
                });

                HotkeysManager.Register("PickPocketOn", Keys.P, ModifierKeys.Alt, ret =>                     //PICKPOCKET
                {
                    PickPocketOn = !PickPocketOn;
                    Logging.Write(Colors.Azure, PickPocketOn ? "Pickpocketing: Enabled!" : "Pickpocketing: Disabled");
                });

                HotkeysManager.Register("HealingOn", Keys.D3, ModifierKeys.Control, ret =>                     //HEALING            3
                {
                    HealingOn = !HealingOn;
                    Logging.Write(Colors.Azure, HealingOn ? "Healing: Enabled!" :"Healing: Disabled!");
                });

                HotkeysManager.Register("StealthOn", Keys.D4, ModifierKeys.Control, ret =>                     //STEALTH            4
                {
                    StealthOn = !StealthOn;
                    Logging.Write(Colors.Azure,StealthOn ? "Always Stealth: Enabled!": "Always Stealth: Disabled!");
                });

                HotkeysManager.Register("FeintOn", Keys.D6, ModifierKeys.Control, ret =>                     //FEINT
                {
                    FeintOn = !FeintOn;
                    Logging.Write(Colors.Azure, FeintOn ? "Always Feint: Enabled!" : "Always FeintOn: Disabled!");
                });

                HotkeysManager.Register("VanishOn", Keys.D8, ModifierKeys.Control, ret =>                     //VANISH
                {
                    autoVanishOn = !autoVanishOn;
                    Logging.Write(Colors.Azure, autoVanishOn ? "Vanish CD: Enabled!" : "Vanish: Disabled!");
                });

                HotkeysManager.Register("RaidOn", Keys.F2, ModifierKeys.Shift, ret =>                     //RAID MODE
                {
                    RaidOn = true;
					aoeOn = false;
					cooldownsOn = true;
					AlwaysSpeedOn = false;
					HealingOn = false;
					StealthOn = true;
                    Logging.Write(Colors.Azure, RaidOn ? "Raid Mode: Enabled!" : "Raid Mode: Disabled!");
                });
				
				HotkeysManager.Register("SoloOn", Keys.F1, ModifierKeys.Shift, ret =>                     //SOLO MODE
                {
					SoloOn = true;
                    aoeOn = false;
					cooldownsOn = false;
					AlwaysSpeedOn = true;
					HealingOn = true;
					StealthOn = true;
                    Logging.Write(Colors.Azure, SoloOn ? "Solo Mode: Enabled!" : "Solo Mode: Disabled!");
                });

                HotkeysManager.Register("AutoAOEon", Keys.D6, ModifierKeys.Control, ret =>                     //AUTO AOE
                {
                    autoaoeOn = !autoaoeOn;
                    Logging.Write(Colors.Azure, autoaoeOn ? "AutoAOE Mode: Enabled!" : "AutoAOE Mode: Disabled!");
                });

                keysRegistered = true;
                //Lua.DoString(@"print('Hotkeys: \124cFF15E61C Registered!')");
                Logging.Write(Colors.Green, "Hotkeys: Registered!");
            }  
        #endregion

        #region [Method] - Hotkey Removal
            public static void removeHotkeys()
            {
                if (!keysRegistered)
                    return;
                HotkeysManager.Unregister("aoeOn");
                HotkeysManager.Unregister("cooldownsOn");
                HotkeysManager.Unregister("manualOn");
                HotkeysManager.Unregister("AlwaysSpeedOn");
                HotkeysManager.Unregister("PickPocketOn");
                HotkeysManager.Unregister("HealingOn");
                HotkeysManager.Unregister("StealthOn");
                HotkeysManager.Unregister("FeintOn");
                HotkeysManager.Unregister("RaidOn");
				HotkeysManager.Unregister("SoloOn");
                HotkeysManager.Unregister("AutoAOEon");
                HotkeysManager.Unregister("AutoVanishon");
                aoeOn = false;
                cooldownsOn = false;
                manualOn = false;
                AlwaysSpeedOn = false;
                PickPocketOn = false;
                HealingOn = false;
                StealthOn = false;
                FeintOn = false;
                RaidOn = false;
				SoloOn = false;
                autoaoeOn = false;
                autoVanishOn = false;

                keysRegistered = false;
                //Lua.DoString(@"print('Hotkeys: \124cFFE61515 Removed!')");
                Logging.Write(Colors.OrangeRed, "Hotkeys: Removed!");
            } 
        #endregion
    }
}